/** \file
 * This file only contains utility stuff on top of the abstract syntax tree
 * structure generated by \ref tree-gen based on `cqasm-ast.tree`. Refer to
 * the cqasm::ast namespace documentation for more information.
 */

#pragma once

#include "cqasm-tree.hpp"

#include <sstream>
#include <string>

namespace cqasm {
namespace ast {

/**
 * Special/temporary string builder node, used to build strings from fragments
 * and escape sequences while parsing. This is abstracted out of the AST; it
 * should never appear after parsing completes.
 */
struct StringBuilder : public cqasm::tree::Base {
    std::ostringstream stream;

    /**
     * Pushes a string fragment into the string.
     */
    void push_string(const std::string &str);

    /**
     * Pushes an escape sequence into the string.
     */
    void push_escape(const std::string &escape);
};

} // namespace ast
} // namespace cqasm
